﻿using System;
using System.Web;
using System.Text;

namespace Interval.CZ.Common.WebHttpModules
{

  public class PathInfo2QueryString : System.Web.IHttpModule
  {

    public void Init(System.Web.HttpApplication objApplication )
    {
      objApplication.BeginRequest += new EventHandler(this.Application_BeginRequest);
    }

    private void Application_BeginRequest (Object obj, EventArgs e)
    {
      string myAppPath = string.Empty;
      if (obj != null)
      {
        System.Web.HttpApplication objHttpApplication = (System.Web.HttpApplication) obj;
        try
        {
          myAppPath = objHttpApplication.Request.FilePath;
          string RequestedExtension = System.IO.Path.GetExtension(myAppPath);
          if (String.Compare(RequestedExtension,".aspx",true) != 0)
            return;
          else
          {
            string originalQueryString = objHttpApplication.Request.QueryString.ToString();
            StringBuilder NewQueryString = new StringBuilder(String.Empty);
   
            if (objHttpApplication.Request.PathInfo.Length > 1)
            {
              char [] delimiter = ("/").ToCharArray();
              String strParams = objHttpApplication.Request.PathInfo.Substring(1);
      
              if (strParams.EndsWith("/"))
                strParams = strParams.Remove(strParams.Length-1,1);
      
              String [] parameters = strParams.Split(delimiter);
              Int32 pCounter = 0;
              StringBuilder pathInfo2QueryString = new StringBuilder(String.Empty);
      
              while (pCounter < parameters.Length)
              {
                if (parameters[pCounter].Length > 0)
                {
                  if (pathInfo2QueryString.Length > 1)
                    pathInfo2QueryString.Append("&");
                  pathInfo2QueryString.Append(parameters[pCounter] + "=");
                  pCounter++;
                  if (pCounter < parameters.Length)
                  {
                    if (parameters[pCounter].Length > 0)
                      pathInfo2QueryString.Append(parameters[pCounter]);
                  }
                }
                pCounter++;
              }
              NewQueryString.Append(pathInfo2QueryString);
            }
            if (originalQueryString.Length > 0)
            {
              if (NewQueryString.Length > 1)
                NewQueryString.Append("&");
              NewQueryString.Append(originalQueryString);
            }
            objHttpApplication.Context.RewritePath(myAppPath, String.Empty, NewQueryString.ToString());
          }
        }
        catch
        {
          return;
        }
      }
      else
        return;
    }
    public void Dispose ()
    {
      // No unmanaged objects to dispose of
    }
  }
}
